# Player handling
execute as @a[tag=!registered] at @s run function chop:player_handling/game
execute as @a[scores={leave=1..}] at @s run function chop:player_handling/game

# Spawning
function chop:game/count_mobs
function chop:game/spawn_timer

# Crafting & Mining
function chop:game/crafting_check
function chop:game/mining_check
execute at @e[type=marker,tag=resource,tag=rock] if block ~ ~ ~ air run setblock ~ ~ ~ stone
execute at @e[type=marker,tag=resource,tag=iron] if block ~ ~ ~ air run setblock ~ ~ ~ stone
execute at @e[type=marker,tag=resource,tag=gold] if block ~ ~ ~ air run setblock ~ ~ ~ gold_block

# Armor modification (runs in second_tick.mcfunction)
# execute as @a[gamemode=adventure,nbt={Inventory:[{tag:{Damage:0}}]}] run function chop:game/modify_armor

# Blindness
execute unless score flash effect matches 1.. run effect give @a[nbt=!{ActiveEffects:[{Id:15b}]},gamemode=!creative,tag=!no_blind] blindness 1000000 100 true

# Insanity
tag @a[tag=in_base] remove in_base
execute positioned -41.0 99.0 -6.0 run tag @a[gamemode=adventure,dy=5,dx=10,dz=10] add in_base
execute as @a[gamemode=adventure,tag=!spectate] at @s run function chop:game/insanity

# Candles
tag @a[tag=in_candle] remove in_candle
execute as @e[type=slime,tag=candle] at @s run function chop:game/candle

# Spirits
execute if score unlockedSpiritOrb vars matches 0 if entity @a[nbt={Inventory:[{id:"minecraft:diamond"}]}] run function chop:game/unlock_spirit_orb
execute as @e[type=armor_stand,tag=spirit] at @s run function chop:game/spirits/loop

# Chaos monster
execute as @e[type=zombie,tag=chaos] at @s run function chop:game/chaos/loop
execute unless entity @e[type=zombie,tag=chaos] unless score chaosDead vars matches 1 run function chop:game/chaos/death

# Regeneration
# effect give @a[tag=in_candle,nbt=!{ActiveEffects:[{Id:10b}]},scores={health=..19}] regeneration 2 1 true
effect give @a[tag=in_base,nbt=!{ActiveEffects:[{Id:10b}]},scores={health=..19}] regeneration 2 2 true
execute as @a[tag=in_base,nbt=!{ActiveEffects:[{Id:10b}]}] run effect give @s[nbt={ActiveEffects:[{Id:22b}]},scores={health=..23}] regeneration 2 2 true

# Vision Potion
execute as @a[scores={drinkPotion=1..}] run function chop:game/drink_potion
execute as @a[scores={visionTime=1..}] run scoreboard players remove @s visionTime 1
execute as @a[scores={visionTime=..0}] unless score chaosDead vars matches 1 run tag @s remove no_blind
execute as @a[scores={visionTime=..0}] run scoreboard players reset @s visionTime

# Torch
execute as @a[nbt={SelectedItem:{id:"minecraft:torch"}}] run item modify entity @s weapon.mainhand chop:torch
execute as @a[scores={breakTorchW=1..}] run function chop:game/break_torch
execute as @a[scores={breakTorch=1..}] run function chop:game/break_torch

# Revive totem
execute unless entity @a[gamemode=adventure] as @e[type=item,nbt={Item:{id:"minecraft:snowball"}}] at @s run function chop:game/use_revive
execute as @a[scores={useRevive=1..}] at @s run function chop:game/use_revive

# Death
execute as @a[gamemode=adventure] if score @s insanity >= maxInsanity vars run function chop:game/insanity_death
execute as @a[scores={death=1..},tag=!spectate] at @s run function chop:game/death

# Time
execute if score runTime vars matches 1 run function chop:game/time

# 5 Tick Timer
scoreboard players add 5_tick timer 1
execute if score 5_tick timer matches 5.. run function chop:game/5tick_timer

# Compass
execute as @a[gamemode=adventure,nbt=!{Inventory:[{id:"minecraft:compass",Count:1b}]}] run function chop:game/get_compass

# Spectators
execute as @a[tag=spectate] at @s unless entity @p[distance=..1.5,gamemode=!spectator] run function chop:game/spectate_player

# Game Over
execute store result score players vars if entity @a[gamemode=adventure]
execute if score chaosDead vars matches 1 as @a[gamemode=adventure] at @s if block ~ 1 ~ emerald_block run function chop:game/win
execute if score players vars matches 0 if entity @a[tag=win] run function chop:game/game_won
execute if score players vars matches 0 unless entity @a[tag=win] unless entity @e[type=item,nbt={Item:{id:"minecraft:snowball"}}] run function chop:game/game_over